#include "cwebfiles.h"

// these routines don't respect nullbytes!

// we use fast hex. start from 'a'. no checks performed (apart from length validity).
// out must be half the size of in
void unhex(unsigned char *out, char *in, size_t in_len) {
  in_len = in_len & ~1; // input length mod 2 must be 0 - mask out the last bit
  char *in_end = in + in_len;
  while (in != in_end) {
    unsigned char in1 = *(in++), in2 = *(in++);
    *(out++) = (in1 - 'a') << 4 | (in2 - 'a');
  }
}

// out must be twice the size of in
void hex(char *out, unsigned char *in, size_t in_len) {
  unsigned char *in_end = in+in_len;
  while (in != in_end) {
    *(out++) = (*in >> 4) + 'a';
    *(out++) = (*in & 0xf) + 'a';
    in++;
  }
}

bool checkhex(char *p, size_t l) {
  if ((l&1) == 1) return false;
  char *e = p+l;
  while (p<e) {
    if (*p < 'a') return false;
    if (*p >= 'a'+16) return false;
    p++;
  }
  return true;
}
